forked from gouthampradhan/leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
CoinChange.java
63 lines (59 loc) · 2.29 KB
/
CoinChange.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
package dynamic_programming;
/**
* Created by gouthamvidyapradhan on 23/06/2017.
* You are given coins of different denominations and a total amount of money amount.
* Write a function to compute the fewest number of coins that you need to make up that amount.
* If that amount of money cannot be made up by any combination of the coins, return -1.
* <p>
* Example 1:
* coins = [1, 2, 5], amount = 11
* return 3 (11 = 5 + 5 + 1)
* <p>
* Example 2:
* coins = [2], amount = 3
* return -1.
* <p>
* Note:
* You may assume that you have an infinite number of each kind of coin.
* <p>
* Solution:
* For example if you have N coins and amount equal to Q
* For every coin you have two options
* i) If you chose to include this coin then, total amount reduces by the sum equivalent to the value of this coin and you are
* left with N coins and Q = (Q - value of this coin)
* ii) If you chose not to include this coin then, you are left with N - 1 coins (since you chose to not to include this coin)
* and total amount is still equal to Q
* <p>
* Calculate recursively for each coin and possible amount
* Since there can be overlapping sub-problems you can save the state in a 2D matrix - a typical DP approach.
* <p>
* For each state minimum is calculated using -> Min(1 + fn(i, amount - v[i]), fn(i + 1, amount))
* <p>
* Worst-case time complexity is O(N x Q) where N is the total number of coins and Q is the total amount
*/
public class CoinChange {
private int[][] DP;
/**
* Main method
*
* @param args
* @throws Exception
*/
public static void main(String[] args) throws Exception {
int[] coins = {1, 2, 5};
System.out.println(new CoinChange().coinChange(coins, 11));
}
public int coinChange(int[] coins, int amount) {
DP = new int[coins.length][amount + 1];
int result = dp(amount, 0, coins);
if (result == Integer.MAX_VALUE - 1) return -1;
return result;
}
private int dp(int amount, int i, int[] coins) {
if (amount == 0) return 0;
else if (i >= coins.length || amount < 0) return Integer.MAX_VALUE - 1;
if (DP[i][amount] != 0) return DP[i][amount];
DP[i][amount] = Math.min(1 + dp(amount - coins[i], i, coins), dp(amount, i + 1, coins));
return DP[i][amount];
}
}